class NumSeq
	def interpolate
		if block_given? then
			n_inf = n_sup = self.n_min
			while true 
				# find the next defined element
				n = n_sup + 1
				n_inf = n_sup
				while n <= self.n_max
					begin
						next if nil == self[n]
						n_sup = n
						break	
					ensure
						n += 1
					end 		
				end
				(n_inf..n_sup).each do |m|
					self[m] = yield(n_inf,n_sup, m)
				end
			break if self.n_max == n_sup
			end
		else
		# perform linear interpolation by default
			self.interpolate do |n0,n1,k;m| 
				m = (self[n1] - self[n0])
				# to avoid integer divisions
				m *= 1.0 if m.is_a? Numeric
				m /= n1 - n0
				next (self[n0] + m * (k - n0))	
			end
		end
		return self
	end
end
