class NumSeq
	def +(arg)
		use_proper_operator(arg, :isum, :xsum)
	end
	
	def -(arg)
		use_proper_operator(arg, :isub, :xsub)
	end
	
	def *(arg)
		use_proper_operator(arg, :imul, :xmul)
	end

	def /(arg)
		use_proper_operator(arg, :idiv, :xdiv)
	end
	
	def %(arg)
		use_proper_operator(arg, :imod, :xmod)
	end
	
	def **(arg)
		use_proper_operator(arg, :iexp, :xexp)
	end

	def use_proper_operator(arg, internal_operator, external_operator)
		if arg.is_a? Numeric then
			return self.send(external_operator, arg)	
		elsif arg.is_a? NumSeq then
			return self.send(internal_operator, arg)
		else
			raise(ArgumentError, "Attempt to operate an object " + 
			"of the '#{self.class}' class with an object " +
			"of the '#{arg.class}' class using the " +
			"'#{caller[0][/`.*'/][1..-2]}' operator")
		end	 
	end
	private :use_proper_operator
end
